#!/bin/bash

## ------------------------------------------------------------------------
## UFPR, BCC, ci210 2020-2 laboratorio combinacional, Roberto Hexsel, 20mar
## ------------------------------------------------------------------------

## ESTE ARQUIVO NAO PODE SER ALTERADO


# set -x

# se passar um argumento para script, executa gtkwave
if [ $# = 1 ] ; then WAVE="yes"
else  WAVE=
fi


sim=estrut
tb=mux
src="packageWires aux ${sim} tb_${tb}"
simulador=tb_${tb}
visual=v_${tb}.vcd
config=v_${tb}.sav

# compila simulador
rm -f log.txt $visual 
ghdl --remove
for F in ${src} ; do
    ghdl -a --std=02 --ieee=standard -fexplicit ${F}.vhd  || exit 1
done

ghdl -e --std=02 --ieee=standard -fexplicit ${simulador}  || exit 1

if [ -n "$WAVE" ] ; then
    ./${simulador} --ieee-asserts=disable --stop-time=500ns \
        --vcd=${visual} &&\
    # executa gtkwave sob demanda
    gtkwave -O /dev/null ${visual} ${config} &
else
    ./${simulador} --ieee-asserts=disable --stop-time=500ns --vcd=/dev/null
fi

